using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadTabStripTabulation
{
    public partial class Form1 : Form
    {
        bool isTabulatedByIndex = false;
        bool isNextTabFound = false;

        public Form1()
        {
            InitializeComponent();
        }

        #region Process Tab key

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            bool baseResult = base.ProcessCmdKey(ref msg, keyData);

            if (keyData == Keys.Tab && this.radTabStrip1.Focused)
            {
                if (isTabulatedByIndex == true)
                {
                    TabByIndex();
                }
                else
                {
                    TabByTag();
                }
                return true;
            }
            return baseResult;
        }

        #endregion

        #region TabByTag

        private void TabByTag()
        {
            isNextTabFound = false;
            int index = int.Parse(((TabItem)this.radTabStrip1.SelectedTab).Tag.ToString());
            foreach (TabItem tab in this.radTabStrip1.Items)
            {
                int futureIndex = int.Parse(tab.Tag.ToString());
                if (futureIndex == index + 1)
                {
                    this.radTabStrip1.SelectedTab = tab;
                    isNextTabFound = true;
                    break;
                }
            }
            if (isNextTabFound == false)
            {
                foreach (TabItem tab in this.radTabStrip1.Items)
                {
                    if (tab.Tag.ToString() == "0")
                    {
                        this.radTabStrip1.SelectedTab = tab;
                    }
                }
            }
        }

        #endregion

        #region TabByIndex

        private void TabByIndex()
        {
            int index = this.radTabStrip1.Items.IndexOf((TabItem)this.radTabStrip1.SelectedTab);
            if (index < this.radTabStrip1.Items.Count - 1)
            {
                this.radTabStrip1.SelectedTab = this.radTabStrip1.Items[index + 1];
            }
            else
            {
                this.radTabStrip1.SelectedTab = this.radTabStrip1.Items[0];
            }
        }

        #endregion

        #region Change approaches

        private void radToggleButton1_ToggleStateChanged(object sender, StateChangedEventArgs args)
        {
            if (radToggleButton1.ToggleState == Telerik.WinControls.Enumerations.ToggleState.On)
            {
                isTabulatedByIndex = true;
                lblState.Text = "Tabulated by Index";
            }
            else
            {
                isTabulatedByIndex = false;
                lblState.Text = "Tabulated by Tag";
            }
        }

        #endregion
    }
}